<?php 
/*****************************************************<br />
 CURL 非阻塞调用类<br />
 Auther: Linvo<br />
 Copyright(C) 2010/10/21<br />
*******************************************************/<br />
/*<br />
    // 使用范例<br />
    // 传入参数说明<br />
    // url  请求地址<br />
    // data POST方式数据<br />
    //并发调用<br />
    $param1 = array(<br />
            array(<br />
                'url' => "http://localhost/a.php?s=1",<br />
                ),<br />
            array(<br />
                'url' => "http://localhost/a.php?s=1",<br />
                'data' => array('aaa' => 1, 'bbb' => 2),<br />
                ),<br />
            );</p>
<p>    //单个调用<br />
    $param2 = array(<br />
            'url' => "http://localhost/a.php?s=0",<br />
            'data' => array('aaa' => 1, 'bbb' => 2),<br />
            ); </p>
<p>    //单个调用（GET简便方式）<br />
    $param3 = 'http://localhost/a.php?s=2';<br />
    $ac = new AsyncCURL();<br />
    $ac->set_param($param1);<br />
    $ret = $ac->send();<br />
    //返回值为请求参数顺序的结果数组（元素值为False表示请求错误）<br />
    var_dump($ret);<br />
*/</p>
<p>class AsyncCURL<br />
{<br />
    /**<br />
     * 是否需要返回HTTP头信息<br />
     */<br />
    public $curlopt_header = 0;<br />
    /**<br />
     * 单个CURL调用超时限制<br />
     */<br />
    public $curlopt_timeout = 20;<br />
    private $param = array();<br />
    /**<br />
     * 构造函数（可直接传入请求参数）<br />
     *<br />
     * @param array 可选<br />
     * @return void<br />
     */<br />
    public function __construct($param = False)<br />
    {<br />
        if ($param !== False)<br />
        {<br />
            $this->param = $this->init_param($param);<br />
        }<br />
    }<br />
    /**<br />
     * 设置请求参数<br />
     *<br />
     * @param array<br />
     * @return void<br />
     */<br />
    public function set_param($param)<br />
    {<br />
        $this->param = $this->init_param($param);<br />
    }</p>
<p>    /**<br />
     * 发送请求<br />
     *<br />
     * @return array<br />
     */<br />
    public function send()<br />
    {<br />
        if(!is_array($this->param) || !count($this->param))<br />
        {<br />
            return False;<br />
        }<br />
        $curl = $ret = array();<br />
        $handle = curl_multi_init();<br />
        foreach ($this->param as $k => $v)<br />
        {<br />
            $param = $this->check_param($v);<br />
            if (!$param) $curl[$k] = False;<br />
            else $curl[$k] = $this->add_handle($handle, $param);<br />
        }<br />
        $this->exec_handle($handle);<br />
        foreach ($this->param as $k => $v)<br />
        {<br />
            if ($curl[$k])<br />
            {<br />
                $ret[$k] = curl_multi_getcontent($curl[$k]);<br />
                curl_multi_remove_handle($handle, $curl[$k]);<br />
            } else {<br />
                $ret[$k] = False;<br />
            }<br />
        }<br />
        curl_multi_close($handle);<br />
        return $ret;<br />
    }<br />
    //以下为私有方法<br />
    private function init_param($param)<br />
    {<br />
        $ret = False;<br />
        if (isset($param['url']))<br />
        {<br />
            $ret = array($param);<br />
        } else {<br />
            $ret = isset($param[0]) ? $param : False;<br />
        }<br />
        return $ret;<br />
    }<br />
    private function check_param($param = array())<br />
    {<br />
        $ret = array();<br />
        if (is_string($param))<br />
        {<br />
            $url = $param;<br />
        } else {<br />
            extract($param);<br />
        }<br />
        if (isset($url))<br />
        {<br />
            $url = trim($url);<br />
            $url = stripos($url, 'http://') === 0 ? $url : NULL;<br />
        }<br />
        if (isset($data) && is_array($data) && !empty($data))<br />
        {<br />
            $method = 'POST';<br />
        } else {<br />
            $method = 'GET';<br />
            unset($data);<br />
        }<br />
        if (isset($url)) $ret['url'] = $url;<br />
        if (isset($method)) $ret['method'] = $method;<br />
        if (isset($data)) $ret['data'] = $data;<br />
        $ret = isset($url) ? $ret : False;<br />
        return $ret;<br />
    }<br />
    private function add_handle($handle, $param)<br />
    {<br />
        $curl = curl_init();<br />
        curl_setopt($curl, CURLOPT_URL, $param['url']);<br />
        curl_setopt($curl, CURLOPT_HEADER, $this->curlopt_header);<br />
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);<br />
        curl_setopt($curl, CURLOPT_TIMEOUT, $this->curlopt_timeout);<br />
        if ($param['method'] == 'POST')<br />
        {<br />
            curl_setopt($curl, CURLOPT_POST, 1);<br />
            curl_setopt($curl, CURLOPT_POSTFIELDS, $param['data']);<br />
        }<br />
        curl_multi_add_handle($handle, $curl);<br />
        return $curl;<br />
    }<br />
    private function exec_handle($handle)<br />
    {<br />
        $flag = null;<br />
        do {<br />
            curl_multi_exec($handle, $flag);<br />
        } while ($flag > 0);<br />
    }<br />
}